Index: orxonox/branches/levelloader/src/lib/util/resource_manager.cc
===================================================================
--- orxonox/branches/levelloader/src/lib/util/resource_manager.cc	(revision 3746)
+++ orxonox/branches/levelloader/src/lib/util/resource_manager.cc	(revision 3746)
@@ -0,0 +1,499 @@
+/* 
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Benjamin Grauer
+   co-programmer: Patrick Boenzli
+*/
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_LOAD
+
+#include "resource_manager.h"
+
+// different resource Types
+#include "objModel.h"
+#include "primitive_model.h"
+#include "texture.h"
+
+#include "list.h"
+
+// File Handling Includes
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <unistd.h>
+
+using namespace std;
+
+/**
+   \brief standard constructor
+*/
+ResourceManager::ResourceManager () 
+{
+   this->setClassName ("ResourceManager");
+   this->dataDir = "./";
+   this->imageDirs = new tList<char>();
+   this->resourceList = new tList<Resource>();
+}
+
+/**
+   \returns the Instance to this ResourceManager
+*/
+ResourceManager* ResourceManager::getInstance(void)
+{
+  if (!ResourceManager::singletonRef)
+    ResourceManager::singletonRef = new ResourceManager();
+  return ResourceManager::singletonRef;
+}
+
+//! Singleton Reference to the ResourceManager
+ResourceManager* ResourceManager::singletonRef = NULL;
+
+/**
+   \brief standard destructor
+*/
+ResourceManager::~ResourceManager (void) 
+{
+  // deleting the Resources-List
+  this->unloadAllByPriority(RP_GAME);
+  delete this->resourceList;
+  // deleting the Directorie Lists
+  tIterator<char>* tmpIt = imageDirs->getIterator();
+  char* tmpDir = tmpIt->nextElement();
+  while(tmpDir)
+    {
+      delete []tmpDir;
+      tmpDir = tmpIt->nextElement();
+    }
+  delete tmpIt;
+
+  delete this->imageDirs;
+
+  ResourceManager::singletonRef = NULL;
+}
+
+/**
+   \brief sets the data main directory
+   \param dataDir the DataDirectory.
+*/
+bool ResourceManager::setDataDir(char* dataDir)
+{
+  if (isDir(dataDir))
+    {
+      this->dataDir = new char[strlen(dataDir)+1];
+      strcpy(this->dataDir, dataDir);
+    }
+  else
+    {
+      PRINTF(1)("%s is not a Directory, and can not be the Data Directory\n", dataDir);
+    }
+}
+
+/**
+   \brief adds a new Path for Images
+   \param imageDir The path to insert
+   \returns true, if the Path was well and injected (or already existent within the list)
+   false otherwise
+*/
+bool ResourceManager::addImageDir(char* imageDir)
+{
+  // check if the param is a Directory
+  if (isDir(imageDir))
+    {
+      // check if the Directory has been added before
+      tIterator<char>* tmpImageDirs = imageDirs->getIterator();
+      char* tmpDir = tmpImageDirs->nextElement();
+      while(tmpDir)
+	{
+	  if (!strcmp(tmpDir, imageDir))
+	    {
+	      PRINTF(4)("Path %s already loaded\n", imageDir);
+	      delete tmpImageDirs;
+	      return true;
+	    }
+	  tmpDir = tmpImageDirs->nextElement();
+	}
+      delete tmpImageDirs;
+
+      // adding the directory to the List
+      tmpDir  = new char[strlen(imageDir)+1];
+      strcpy(tmpDir, imageDir);
+      this->imageDirs->add(tmpDir);
+      return true;
+    }
+  else
+    {
+      PRINTF(1)("%s is not a Directory, and can not be added to the Paths of Images\n", dataDir);
+      return false;
+    }
+}
+
+/**
+   \brief loads resources
+   \param fileName The fileName of the resource to load
+   \param prio The ResourcePriority of this resource (will only be increased)
+   \returns a pointer to a desired Resource.
+*/
+void* ResourceManager::load(const char* fileName, ResourcePriority prio)
+{
+  ResourceType tmpType;
+  if (!strncmp(fileName+(strlen(fileName)-4), ".obj", 4))
+    tmpType = OBJ;
+  else if (!strncmp(fileName+(strlen(fileName)-4), ".wav", 4))
+    tmpType = WAV;
+  else if (!strncmp(fileName+(strlen(fileName)-4), ".mp3", 4))
+    tmpType = MP3;
+  else if (!strncmp(fileName+(strlen(fileName)-4), ".ogg", 4))
+    tmpType = OGG;
+  else if (!strcmp(fileName, "cube") ||
+           !strcmp(fileName, "sphere") ||
+	   !strcmp(fileName, "plane") ||
+           !strcmp(fileName, "cylinder") ||
+           !strcmp(fileName, "cone"))
+    tmpType = PRIM;
+  else 
+    tmpType = IMAGE;
+
+  return this->load(fileName, tmpType, prio);
+}
+
+/**
+   \brief loads resources
+   \param fileName The fileName of the resource to load
+   \param type The Type of Resource to load (\see ResourceType)
+   \param prio The ResourcePriority of this resource (will only be increased)
+   \returns a pointer to a desired Resource.
+*/
+void* ResourceManager::load(const char* fileName, ResourceType type, ResourcePriority prio)
+{
+  // searching if the resource was loaded before.
+  Resource* tmpResource = this->locateResourceByName(fileName);
+  if (tmpResource) // if the resource was not loaded before.
+    {
+      PRINTF(4)("not loading cached resource %s\n", tmpResource->name);
+      tmpResource->count++;
+      if(tmpResource->prio < prio)
+	tmpResource->prio = prio;
+    }
+  else
+    {
+      char* tmpDir;
+      // Setting up the new Resource
+      tmpResource = new Resource;
+      tmpResource->count = 1;
+      tmpResource->type = type;
+      tmpResource->prio = prio;
+      tmpResource->name = new char[strlen(fileName)+1];
+      strcpy(tmpResource->name, fileName);
+
+      // creating the full name. (directoryName + FileName)
+      char* fullName = new char[strlen(dataDir)+strlen(fileName)+1];
+      sprintf(fullName, "%s%s", this->dataDir, fileName);
+      
+      // Checking for the type of resource \see ResourceType
+      switch(type)
+	{
+	case OBJ:
+	  if(isFile(fullName))
+	    tmpResource->pointer = new OBJModel(fullName);
+	  else
+	    {
+	      PRINTF(2)("Sorry, %s does not exist. Loading a cube-Model instead\n", fullName);
+	      tmpResource->pointer = ResourceManager::load("cube", PRIM);
+	    }
+	  break;
+	case PRIM:
+	  if (!strcmp(tmpResource->name, "cube"))
+	    tmpResource->pointer = new PrimitiveModel(CUBE);
+	  else if (!strcmp(tmpResource->name, "sphere"))
+	    tmpResource->pointer = new PrimitiveModel(SPHERE);
+	  else if (!strcmp(tmpResource->name, "plane"))
+	    tmpResource->pointer = new PrimitiveModel(PLANE);
+	  else if (!strcmp(tmpResource->name, "cylinder"))
+	    tmpResource->pointer = new PrimitiveModel(CYLINDER);
+	  else if (!strcmp(tmpResource->name, "cone"))
+	    tmpResource->pointer = new PrimitiveModel(CONE);
+	  break;
+	case IMAGE:
+	  if(isFile(fullName))
+	    {
+	      PRINTF(4)("Image %s resides to %s\n", fileName, fullName);
+	      tmpResource->pointer = new Texture(fullName);
+	    }
+	  else
+	    {
+	      tIterator<char>* iterator = imageDirs->getIterator();
+	      tmpDir = iterator->nextElement();
+	      //tmpDir = imageDirs->enumerate();
+	      while(tmpDir)
+		{
+		  char* imgName = new char[strlen(tmpDir)+strlen(fileName)+1];
+		  sprintf(imgName, "%s%s", tmpDir, fileName);
+		  if(isFile(imgName))
+		    {
+		      PRINTF(4)("Image %s resides to %s\n", fileName, imgName);
+		      tmpResource->pointer = new Texture(imgName);
+		      delete []imgName;
+		      break;
+		    }
+		  delete []imgName;
+		  tmpDir = iterator->nextElement();
+		}
+	      delete iterator;
+	    }
+	  if(!tmpResource)
+	     PRINTF(2)("!!Image %s not Found!!\n", fileName);
+	  break;
+	default:
+	  tmpResource->pointer = NULL;
+	  PRINTF(1)("No type found for %s.\n   !!This should not happen unless the Type is not supported yet.!!\n", tmpResource->name);
+	  break;
+	}
+      this->resourceList->add(tmpResource);
+      delete []fullName;
+    }
+
+  return tmpResource->pointer;
+}
+
+/**
+   \brief unloads a Resource
+   \param pointer The pointer to free
+   \returns true if successful (pointer found, and deleted), false otherwise
+   
+*/
+bool ResourceManager::unload(void* pointer, ResourcePriority prio)
+{
+  // if pointer is existent. and only one resource of this type exists.
+  Resource* tmpResource = this->locateResourceByPointer(pointer);
+  if (!tmpResource)
+    {
+      PRINTF(2)("Resource not Found %p\n", pointer);
+      return false;
+    }
+  else
+    unload(tmpResource, prio);
+}
+
+bool ResourceManager::unload(Resource* resource, ResourcePriority prio)
+{
+  if (resource->count > 0)
+    resource->count--;
+  if (resource->prio <= prio)
+    {
+      if (resource->count <= 0)
+	{
+	  // deleting the Resource
+	  switch(resource->type)
+	    {
+	    case OBJ:
+	    case PRIM:
+	      delete (Model*)resource->pointer;
+	      break;
+	    case IMAGE:
+	      delete (Texture*)resource->pointer;
+	      break;
+	    default:
+	      PRINTF(1)("NOT YET IMPLEMENTED !!FIX FIX!!\n");
+	      return false;
+	      break;
+	    }
+	  // deleting the List Entry:
+	  PRINTF(4)("Resource %s safely removed.\n", resource->name);
+	  delete []resource->name;
+	  this->resourceList->remove(resource);
+	}
+      else
+	PRINTF(4)("Resource %s not removed, because there are still %d References to it.\n", resource->name, resource->count);
+    }
+  else
+    PRINTF(4)("not deleting resource %s because DeleteLevel to high\n", resource->name);
+  return true;
+}
+
+
+/**
+   \brief unloads all alocated Memory of Resources with a pririty lower than prio
+   \param prio The priority to delete
+*/
+bool ResourceManager::unloadAllByPriority(ResourcePriority prio)
+{
+  tIterator<Resource>* iterator = resourceList->getIterator();
+  Resource* enumRes = iterator->nextElement();
+  while (enumRes)
+    {
+      if (enumRes->prio <= prio)
+	if (enumRes->count == 0)
+	  unload(enumRes, prio);
+	else
+	  PRINTF(2)("unable to unload %s because there are still %d references to it\n",
+		   enumRes->name, enumRes->count);
+      //enumRes = resourceList->nextElement();
+      enumRes = iterator->nextElement();
+    }
+  delete iterator;
+}
+
+/**
+   \brief Searches for a Resource by Name
+   \param fileName The name to look for
+   \returns a Pointer to the Resource if found, NULL otherwise.
+*/
+Resource* ResourceManager::locateResourceByName(const char* fileName)
+{
+  //  Resource* enumRes = resourceList->enumerate();
+  tIterator<Resource>* iterator = resourceList->getIterator();
+  Resource* enumRes = iterator->nextElement();
+  while (enumRes)
+    {
+      if (!strcmp(fileName, enumRes->name))
+	{
+	  delete iterator;
+	  return enumRes;
+	}
+      enumRes = iterator->nextElement();
+    }
+  delete iterator;
+  return NULL;
+}
+
+/**
+   \brief Searches for a Resource by Pointer
+   \param pointer the Pointer to search for
+   \returns a Pointer to the Resource if found, NULL otherwise.
+*/
+Resource* ResourceManager::locateResourceByPointer(const void* pointer)
+{
+  //  Resource* enumRes = resourceList->enumerate();
+  tIterator<Resource>* iterator = resourceList->getIterator();
+  Resource* enumRes = iterator->nextElement();
+  while (enumRes)
+    {
+      if (pointer == enumRes->pointer)
+	{
+	  delete iterator;
+	  return enumRes;
+	}
+      enumRes = iterator->nextElement();
+    }
+  delete iterator;
+  return NULL;
+}
+
+/**
+   \brief Checks if it is a Directory
+   \param directoryName the Directory to check for
+   \returns true if it is a directory/symlink false otherwise
+   \todo implement for win32 usage too
+   \bug does return false by default on win32
+*/
+bool ResourceManager::isDir(const char* directoryName)
+{
+	#ifdef __WIN32__
+		return false;
+	#elif
+  struct stat status;
+  stat(directoryName, &status);
+  if (status.st_mode & (S_IFDIR | S_IFLNK))
+    return true;
+  else
+    return false;
+  #endif
+}
+
+/**
+   \brief Checks if the file is either a Regular file or a Symlink
+   \param fileName the File to check for
+   \returns true if it is a regular file/symlink, false otherwise
+   \todo implement fo win32 usage too
+   \bug does return false by default on win32
+*/
+bool ResourceManager::isFile(const char* fileName)
+{
+	#ifdef __WIN32__
+		return false;
+	#elif
+  struct stat status;
+  stat(fileName, &status);
+  if (status.st_mode & (S_IFREG | S_IFLNK))
+    return true;
+  else
+    return false;
+  #endif
+}
+
+/**
+   \brief outputs debug information about the ResourceManager
+*/
+void ResourceManager::debug(void)
+{
+  PRINT(0)("=RM===================================\n");
+  PRINT(0)("= RESOURCE-MANAGER DEBUG INFORMATION =\n");
+  PRINT(0)("======================================\n");
+  // if it is not initialized
+  PRINT(0)(" Reference is: %p\n", ResourceManager::singletonRef);
+  PRINT(0)(" Data-Directory is: %s\n", this->dataDir);
+  PRINT(0)(" List of Image-Directories: ");
+  tIterator<char>* tmpIt = imageDirs->getIterator();
+  char* tmpDir = tmpIt->nextElement();
+  while(tmpDir)
+    {
+      PRINT(0)("%s ",tmpDir);
+      tmpDir = tmpIt->nextElement();
+    }
+  delete tmpIt;
+  PRINT(0)("\n");
+
+  PRINT(0)("List of all stored Resources:\n");
+  tIterator<Resource>* iterator = resourceList->getIterator();
+  Resource* enumRes = iterator->nextElement();
+  while (enumRes)
+    {
+      PRINT(0)("-----------------------------------------\n");
+      PRINT(0)("Name: %s; References: %d; Type:", enumRes->name, enumRes->count);
+      switch (enumRes->type)
+	{
+	case OBJ:
+	  PRINT(0)("ObjectModel\n");
+	  break;
+	case PRIM:
+	  PRINT(0)("PrimitiveModel\n");
+	  break;
+	case IMAGE:
+	  PRINT(0)("ImageFile (Texture)\n");
+	  break;
+	default:
+	  PRINT(0)("SoundFile\n");
+	  break;
+	}
+      PRINT(0)("gets deleted at ");
+      switch(enumRes->prio)
+	{
+	default:
+	case RP_NO:
+	  PRINT(0)("first posibility (0)\n");
+	  break;
+	case RP_LEVEL:
+	  PRINT(0)("the end of the Level (1)\n");
+	  break;
+	case RP_CAMPAIGN:
+	  PRINT(0)("the end of the campaign (2)\n");
+	  break;
+	case RP_GAME:
+	  PRINT(0)("when leaving the game (3)\n");
+	  break;
+	}
+      enumRes = iterator->nextElement();
+    }
+  delete iterator;
+
+
+
+  PRINT(0)("==================================RM==\n");
+}
Index: orxonox/branches/levelloader/src/lib/util/resource_manager.h
===================================================================
--- orxonox/branches/levelloader/src/lib/util/resource_manager.h	(revision 3746)
+++ orxonox/branches/levelloader/src/lib/util/resource_manager.h	(revision 3746)
@@ -0,0 +1,84 @@
+/*! 
+    \file resource_manager.h
+    \brief The Resource Manager checks if a file/resource is loaded.
+
+    If a file/resource was already loaded the resourceManager will 
+    return a void pointer to the desired resource.
+    Otherwise it will instruct the coresponding resource-loader to load,
+    and receive a pointer to it.
+*/
+
+#ifndef _RESOURCE_MANAGER_H
+#define _RESOURCE_MANAGER_H
+
+#include "base_object.h"
+
+// FORWARD DEFINITION \\
+//template<class T> class tList;
+#include "list.h"                //! \todo do this by forward definition (ask Patrick)
+
+//! An eumerator for different fileTypes the resourceManager supports \todo WAV, MP3, OGG support
+enum ResourceType {OBJ, PRIM, WAV, MP3, OGG, IMAGE};
+//! An enumerator for different UNLOAD-types. 
+/**
+   RP_NO: will be unloaded on request
+   RP_LEVEL: will be unloaded at the end of a Level
+   RP_CAMPAIGN: will be unloaded at the end of a Campaign
+   RP_GAME: will be unloaded at the end of the whole Game (when closing orxonox)
+*/
+enum ResourcePriority {RP_NO = 0, RP_LEVEL = 1, RP_CAMPAIGN = 2, RP_GAME = 3};
+
+//! A Struct that keeps track about A resource its name its Type, and so on
+struct Resource
+{
+  void* pointer;             //!< Pointer to the Resource.
+  
+  char* name;                //!< Name of the Resource.
+  ResourceType type;         //!< ResourceType of this Resource.
+  ResourcePriority prio;     //!< The Priority of this resource. (This will only be increased)
+  int count;                 //!< How many times this Resource has been loaded.
+};
+
+
+//! The ResourceManager is a class, that decides if a file/resource should be loaded
+/**
+   If a file/resource was already loaded the resourceManager will 
+   return a void pointer to the desired resource.
+   Otherwise it will instruct the corresponding resource-loader to load,
+   and receive the pointer to it.
+
+   It does it by looking, if a desired file has already been loaded.
+*/
+class ResourceManager : public BaseObject 
+{
+ public:
+  static ResourceManager* getInstance();
+  virtual ~ResourceManager();
+
+  bool setDataDir(char* dataDir);
+  bool addImageDir(char* imageDir);
+  void* load(const char* fileName, ResourcePriority prio = RP_NO);
+  void* load(const char* fileName, ResourceType type, ResourcePriority prio = RP_NO);
+  bool unload(void* pointer, ResourcePriority prio = RP_NO);
+  bool unload(Resource* resource, ResourcePriority = RP_NO);
+  bool unloadAllByPriority(ResourcePriority prio);
+  void debug(void);
+
+ private:
+  ResourceManager();
+  static ResourceManager* singletonRef;
+
+  tList<Resource>* resourceList;       //!< The List of Resources, that has already been loaded.
+  char* dataDir;                       //!< The Data Directory, where all relevant Data is stored.
+  tList<char>* imageDirs;              //!< A list of directories in which images are stored.
+
+
+  Resource* locateResourceByName(const char* fileName);
+  Resource* locateResourceByPointer(const void* pointer);
+  
+  bool isDir(const char* directory);
+  bool isFile(const char* directory);
+
+};
+
+#endif /* _RESOURCE_MANAGER_H */
Index: orxonox/branches/levelloader/src/message_structures.h
===================================================================
--- orxonox/branches/levelloader/src/message_structures.h	(revision 3606)
+++ orxonox/branches/levelloader/src/message_structures.h	(revision 3746)
@@ -6,4 +6,6 @@
 #ifndef _MESSAGE_STRUCTURES_H
 #define _MESSAGE_STRUCTURES_H
+
+#include "stdincl.h"
 
 #define CMD_LENGHT 16
